aboutsummaryrefslogtreecommitdiffstats
path: root/unmaintained/lusca/lusca.initd
diff options
context:
space:
mode:
authorJakub Jirutka <jakub@jirutka.cz>2016-10-18 21:10:54 +0200
committerJakub Jirutka <jakub@jirutka.cz>2016-10-18 21:10:54 +0200
commitf3a6f9ddf387542e9e41ee783b6fb77fb34d4d52 (patch)
treed7777b385eee28dc993bb16f482ec4e4eb157f35 /unmaintained/lusca/lusca.initd
parentf0785ec9c26222cb069cbc688dcb1e71d43463c7 (diff)
downloadaports-f3a6f9ddf387542e9e41ee783b6fb77fb34d4d52.tar.bz2
aports-f3a6f9ddf387542e9e41ee783b6fb77fb34d4d52.tar.xz
unmaintained/lusca: move from testing
This abuild is untouched since 2014. All the later changes are from mass changes across repository.
Diffstat (limited to 'unmaintained/lusca/lusca.initd')
-rw-r--r--unmaintained/lusca/lusca.initd120
1 files changed, 120 insertions, 0 deletions
diff --git a/unmaintained/lusca/lusca.initd b/unmaintained/lusca/lusca.initd
new file mode 100644
index 0000000000..dfe98bcca2
--- /dev/null
+++ b/unmaintained/lusca/lusca.initd
@@ -0,0 +1,120 @@
+#!/sbin/runscript
+# Copyright 1999-2013 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/net-proxy/squid/files/squid.initd-r3,v 1.1 2013/01/11 15:25:49 eras Exp $
+
+extra_started_commands="reload rotate"
+
+depend() {
+ use dns
+ need net
+ after firewall
+}
+
+checkconfig() {
+ if [ ! -f /etc/lusca/${SVCNAME}.conf ]; then
+ eerror "You need to create /etc/lusca/${SVCNAME}.conf first."
+ eerror "An example can be found in /etc/lusca/lusca.conf.default"
+ return 1
+ fi
+
+ local PIDFILE=$(awk '/^[ \t]*pid_filename[ \t]+/ { print $2 }' < /etc/lusca/${SVCNAME}.conf)
+ [ -z ${PIDFILE} ] && PIDFILE=/var/run/lusca.pid
+ if [ /var/run/${SVCNAME}.pid != ${PIDFILE} ]; then
+ eerror "/etc/lusca/${SVCNAME}.conf must set pid_filename to"
+ eerror " /var/run/${SVCNAME}.pid"
+ eerror "CAUTION: http_port, cache_dir and *_log parameters must be different than"
+ eerror " in any other instance of lusca."
+ return 1
+ fi
+
+ local CACHE_SWAP=$(awk '/^[ \t]*cache_dir[ \t]+/ { if ($2 == "coss" ) printf "%s/stripe ", $3 ; else printf "%s/00 ", $3; }' < /etc/lusca/${SVCNAME}.conf)
+ [ -z "$CACHE_SWAP" ] && CACHE_SWAP="/var/cache/lusca/00"
+
+ local x
+ for x in $CACHE_SWAP ; do
+ if [ ! -e $x ] ; then
+ ebegin "Initializing cache directory ${x%/*}"
+ local ORIG_UMASK=$(umask)
+ umask 027
+
+ if ! (mkdir -p ${x%/*} && chown lusca ${x%/*}) ; then
+ eend 1
+ return 1
+ fi
+
+ local INIT_CACHE_RESPONSE="$(/usr/sbin/lusca -z -N -f /etc/lusca/${SVCNAME}.conf 2>&1)"
+ if [ $? != 0 ] || echo "$INIT_CACHE_RESPONSE" | grep -q "erminated abnormally" ; then
+ umask $ORIG_UMASK
+ eend 1
+ echo "$INIT_CACHE_RESPONSE"
+ return 1
+ fi
+
+ umask $ORIG_UMASK
+ eend 0
+ break
+ fi
+ done
+
+ return 0
+}
+
+limits() {
+ ulimit -c unlimited
+ ulimit -d unlimited
+ ulimit -f unlimited
+ ulimit -n 819200
+ ulimit -v unlimited
+ ulimit -s 8192
+ ulimit -l unlimited
+}
+
+start() {
+ checkconfig || return 1
+ ebegin "Starting ${SVCNAME}"
+ limits
+ KRB5_KTNAME="${LUSCA_KEYTAB}" /usr/sbin/lusca ${LUSCA_OPTS} -f /etc/lusca/${SVCNAME}.conf
+ eend $? && sleep 1
+}
+
+stop() {
+ ebegin "Stopping ${SVCNAME}"
+ if /usr/sbin/lusca -k shutdown -f /etc/lusca/${SVCNAME}.conf ; then
+ # Now we have to wait until lusca has _really_ stopped.
+ sleep 1
+ if [ -f /var/run/${SVCNAME}.pid ] ; then
+ einfon "Waiting for lusca to shutdown ."
+ cnt=0
+ while [ -f /var/run/${SVCNAME}.pid ] ; do
+ cnt=$(expr $cnt + 1)
+ if [ $cnt -gt 60 ] ; then
+ # Waited 120 seconds now. Fail.
+ echo
+ eend 1 "Failed."
+ break
+ fi
+ sleep 2
+ echo -n "."
+ done
+ echo
+ fi
+ else
+ eerror "lusca shutdown failed, probably service is already down."
+ fi
+ eend 0
+}
+
+reload() {
+ checkconfig || return 1
+ ebegin "Reloading ${SVCNAME}"
+ /usr/sbin/lusca -k reconfigure -f /etc/lusca/${SVCNAME}.conf
+ eend $?
+}
+
+rotate() {
+ service_started ${SVCNAME} || return 1
+ ebegin "Rotating ${SVCNAME} logs"
+ /usr/sbin/lusca -k rotate -f /etc/lusca/${SVCNAME}.conf
+ eend $?
+}